<app-scenario-menu domain="rating"></app-scenario-menu>
<mat-expansion-panel cookieExpansion="exp-rating-services"
                     [initiallyExpanded]="true">
  <mat-expansion-panel-header>
    <mat-panel-title>
      <div class="mini-fab-icon">
        <div class="davicon icon-GGR-davicons-Font-Simple-3-Standorte-Leistungen"></div>
      </div>
      Leistung
      <mat-icon *ngIf="!planningService.activeService" class="warning"
                title="Keine Leistung ausgewählt">
        error_outline
      </mat-icon>
      <app-help-button title="Leistung" position="right">
        <p>Wählen Sie hier die Leistung aus, für die Sie Indikatoren in der Karte anzeigen möchten.</p>
        <p>Wählen Sie hierzu zunächst im Dropdown-Menü den entsprechenden Infrastrukturbereich und dann per Checkbox die gewünschte Leistung.</p>
      </app-help-button>
    </mat-panel-title>
  </mat-expansion-panel-header>
  <app-service-select></app-service-select>
</mat-expansion-panel>
<mat-expansion-panel cookieExpansion="exp-rating-indicators">
  <mat-expansion-panel-header>
    <mat-panel-title>
      <div class="mini-fab-icon">
        <mat-icon class="material-icons-outlined">lightbulb</mat-icon>
      </div>
      Bewertung
      <mat-icon *ngIf="indicatorErrors.length > 0" class="warning"
                [title]="'Fehler: ' + indicatorErrors.join(' | ')">
        error_outline
      </mat-icon>
      <app-help-button title="Indikator" position="right">
        <p>Wählen Sie hier aus den definierten Indikatoren für die Darstellung aus.</p>
      </app-help-button>
    </mat-panel-title>
  </mat-expansion-panel-header>
  <mat-form-field appearance="outline" class="small" style="margin-top: 12px;"
                  [ngClass]="{ 'invalid': !selectedIndicator }">
    <mat-label>Indikator</mat-label>
    <mat-select disableOptionCentering panelClass="custom-option-panel"
                disableRipple
                [(value)]="selectedIndicator"
                (selectionChange)="onIndicatorChange()"
                [ngbPopover]="selectedIndicatorPopover"
                placement="right"
                container="body"
                triggers="mouseenter:mouseleave">
      <ng-container *ngFor="let indicator of indicators">
        <mat-option [value]="indicator"
                    [ngbPopover]="indicatorPopover"
                    placement="right"
                    container="body"
                    triggers="mouseenter:mouseleave">
          {{indicator.title}}
        </mat-option>
        <ng-template #indicatorPopover>
          <p><b>{{indicator?.title}}</b></p>
          <p>{{indicator?.description}}</p>
        </ng-template>
      </ng-container>
      <ng-template #selectedIndicatorPopover>
        <p><b>{{selectedIndicator?.title}}</b></p>
        <p>{{selectedIndicator?.description}}</p>
      </ng-template>
    </mat-select>
  </mat-form-field>
  <ng-container *ngIf="selectedIndicator?.additionalParameters">
    <div *ngFor="let parameter of selectedIndicator?.additionalParameters"
         style="margin-top: 10px;">
      <ng-container *ngVar="indicatorParams[parameter.name] as value">
        <ng-container *ngIf="parameter.type === 'number' || parameter.type === 'string'">
          <mat-form-field class="small" appearance="outline"
                          [ngClass]="{ 'invalid': (parameter.type === 'number')? (value === undefined || value < (parameter.min || 0) || (parameter.max && value > (parameter.max))): !value }">
            <mat-label>{{parameter.title}}</mat-label>
            <input matInput *ngIf="parameter.type === 'number'" type="number"
                   [value]="value || 0"
                   [min]="parameter.min || 0"
                   [max]="parameter.max || 9999999"
                   (change)="setParam(parameter, $any($event.target).value)">
            <input matInput *ngIf="parameter.type === 'string'"
                   [value]="value || ''"
                   (change)="setParam(parameter, $any($event.target).value!)">
          </mat-form-field>
        </ng-container>
        <ng-container *ngIf="parameter.name === 'mode'">
          <app-mode-select [selected]="value"
                           [label]="parameter.title"
                           (modeChanged)="setParam(parameter, $event);">
          </app-mode-select>
        </ng-container>
      </ng-container>
    </div>
  </ng-container>
</mat-expansion-panel>
<mat-expansion-panel *ngIf="selectedIndicator && selectedIndicator.resultType === 'area'"
                     cookieExpansion="exp-rating-areas">
  <mat-expansion-panel-header>
    <mat-panel-title>
      <div class="mini-fab-icon">
        <mat-icon class="material-icons-outlined">flip_to_front</mat-icon>
      </div>
      Gebietseinteilung
      <mat-icon *ngIf="!selectedAreaLevel" class="warning"
                title="Keine Gebietseinteilung ausgewählt">
        error_outline
      </mat-icon>
      <app-help-button title="Gebietseinteilung" position="right">
        <p>Wählen Sie hier im Dropdown-Menü die jeweilige Gebietseinteilung für die Darstellung aus.</p>
      </app-help-button>
    </mat-panel-title>
  </mat-expansion-panel-header>
  <mat-form-field appearance="outline" class="small"
                  [ngClass]="{ 'invalid': !selectedAreaLevel }">
    <mat-select disableOptionCentering disableRipple
                [(value)]="selectedAreaLevel"
                (selectionChange)="onAreaLevelChange()">
      <mat-option [value]="areaLevel" *ngFor="let areaLevel of areaLevels">
        {{areaLevel.name}}
      </mat-option>
    </mat-select>
  </mat-form-field>
</mat-expansion-panel>
<!--this div is only there to cover glitched shadow of chart toggle-->
<div style="width: 100%; height: 200px; background-color: white;"></div>
<app-side-toggle [class.hidden]="!(selectedIndicator?.resultType === 'area' || selectedIndicator?.resultType === 'place')"
                 id="chart-toggle" icon="bar_chart" name="Diagramm"
                 style="pointer-events: none;"
                 cookieExpansion="exp-rating-diagram">
  <div style="position: relative;">
    <div class="diagram-wrapper">
      <app-horizontal-barchart #barChart
                               [showCSVExport]="true"
                               [showPNGExport]="true"
                               xLabel="Jahre"
                               yLabel="Einwohner"
                               [unit]="this.selectedIndicator?.unit || ''"
                               [animate]="true"
                               [title]="this.selectedIndicator?.title || ''"
                               [subtitle]="barChartProps.subtitle">
      </app-horizontal-barchart>
    </div>
    <app-help-button title="Diagrammdarstellung"
                     position="right"
                     style="position: absolute; left: 5px; top: -5px; z-index: 1;">
      <p>Das Diagramm zeigt die Ergebniswerte der ausgewählten Bewertung für alle Gebiete der ausgewählten Gebietseinteilung.</p>
      <p>Über den Button mit dem Fotoapparat können Sie sich das Diagramm als Bild (PNG) herunterladen.</p>
      <p>Über den Button mit dem Dokument laden Sie die Werte als CSV-Datei herunter.</p>
    </app-help-button>
  </div>
</app-side-toggle>

<ng-template #diagramDialog>
  <div style="overflow-y: auto; max-height: 80vh;">
    <img src="{{backend}}/static/img/Indikator U3 Screenshot.png" width="100%">
  </div>
  <div style="width: 100%; display: flex; justify-content: center;">
    <app-time-slider id="time-slider" [prognosisStart]="2013" [years]="[2009, 2010, 2012, 2013, 2015, 2017, 2020, 2025]"></app-time-slider>
  </div>
</ng-template>
